// $Id: dfd.cxx,v 1.3 1997/06/28 21:09:13 cnidr Exp $
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact.

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of
noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
************************************************************************/

/*@@@
File:		dfd.cxx
Version:	1.00
$Revision: 1.3 $
Description:	Class DFD - Data Field Definition
Author:		Nassib Nassar, nrn@cnidr.org
@@@*/

/*
#include "string.hxx"
#include "attr.hxx"
#include "attrlist.hxx"
*/

#include "dfd.hxx"


DFD::DFD() {
  FileNumber = 0;
}


DFD& 
DFD::operator=(const DFD& OtherDfd) {
  //	FieldName = OtherDfd.FieldName;
  FileNumber = OtherDfd.FileNumber;
  Attributes = OtherDfd.Attributes;
  return *this;
}


void 
DFD::SetFieldName(const STRING& NewFieldName) {
  //	FieldName = NewFieldName;
  //	FieldName.UpperCase();
  Attributes.AttrSetFieldName(NewFieldName);
}


void 
DFD::GetFieldName(STRING *StringBuffer) const {
  //	*StringBuffer = FieldName;
  Attributes.AttrGetFieldName(StringBuffer);
}


void 
DFD::SetFieldType(const STRING& NewFieldType) {
  Attributes.AttrSetFieldType(NewFieldType);
}


void 
DFD::GetFieldType(STRING *StringBuffer) const {
  Attributes.AttrGetFieldType(StringBuffer);
}


void 
DFD::SetFileNumber(const INT NewFileNumber) {
  FileNumber = NewFileNumber;
}


INT 
DFD::GetFileNumber() const {
  return FileNumber;
}


void 
DFD::SetAttributes(const ATTRLIST& NewAttributes) {
  Attributes = NewAttributes;
}


void DFD::GetAttributes(ATTRLIST *AttributesBuffer) const {
  *AttributesBuffer = Attributes;
}


DFD::~DFD() {
}
