/* $Id: db_Isearch.hxx,v 1.3 1997/05/05 21:46:03 cnidr Exp $ */
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:		db_Isearch.hxx
Version:	$Revision: 1.3 $
Description:	SAPI Isearch database object
Author:		Kevin Gamiel, kevin.gamiel@cnidr.org
@@@*/

#ifndef _DB_ISEARCH_HXX_
#define _DB_ISEARCH_HXX_

#include "sapi_db.hxx"
#include "rset_Isearch.hxx"


class SAPI_DB_ISEARCH 
  : public SAPI_DB {
private:
    STRING i_records_directory;
    friend SAPI_RSET_ISEARCH;

protected:
    IDB *i_idb;

public:
    SAPI_DB_ISEARCH(const STRING & Name, REGISTRY *Registry);
    ~SAPI_DB_ISEARCH();

    GDT_BOOLEAN	Initialize(STRING pass);
    SAPI_RSET	*Search(const ZSQUERY & Query);
    GDT_BOOLEAN     Add_Record(const STRING &Key, const STRING &Data);
    GDT_BOOLEAN   Delete_Record(const STRING &Key);
    //  void            GetFieldNames(SAPI_DB_ISEARCH *d, 
    //STRLIST *FieldNames); 
    void          GetFieldNames(STRLIST *FieldNames);
};

#endif
