#include "defs.hxx"      
#include "string.hxx"    
#include "vlist.hxx"                                                     
#include "attr.hxx"                                                
#include "attrlist.hxx"  
#include "strlist.hxx"                                                 
#include "strstack.hxx"                                                  
#include "nfield.hxx" 
#include "mdtrec.hxx" 
#include "mdt.hxx"                                                    
#include "dfd.hxx"                                                    
#include "dfdt.hxx"                                                     
#include "fc.hxx"                    
#include "fct.hxx"    
#include "df.hxx"                                                       
#include "dft.hxx"                                                      
#include "record.hxx"                                                     
#include "result.hxx"  
#include "idbobj.hxx"  
#include "iresult.hxx"                                                    
#include "opobj.hxx"                                                     
#include "operand.hxx"                                                    
#include "termobj.hxx" 
#include "sterm.hxx"                                              
#include "rset.hxx"                                                      
#include "irset.hxx"                                   
#include "opstack.hxx" 
#include "squery.hxx"                                              
#include "dtreg.hxx"                                                    
#include "rcache.hxx"                                                     
#include "index.hxx"                                                    
#include "fprec.hxx"                                       
#include "fpt.hxx"                                                       
#include "registry.hxx"
#include "idb.hxx"   
#include "dfd.hxx"
#include "dfdt.hxx"

#include "db_conf.hxx"

//
// Add specific database driver include files here
//
#include "db_Isearch.hxx"
#include "db_zclient.hxx"
#include "db_script.hxx"

SAPI_DB *NewSAPI_DB(const STRING & TypeName, const STRING & Name,
	REGISTRY *Registry)
{
	//
	// Add all database driver types here
	//
	if(TypeName.CaseEquals("ISEARCH"))
		return (SAPI_DB *)new SAPI_DB_ISEARCH(Name, Registry);
	if(TypeName.CaseEquals("ZCLIENT"))
		return (SAPI_DB *)new SAPI_DB_ZCLIENT(Name, Registry);
	if(TypeName.CaseEquals("SCRIPT"))
		return (SAPI_DB *)new SAPI_DB_SCRIPT(Name, Registry);


	return (SAPI_DB *)NULL;
}

