/* $Id: db_zclient.hxx,v 1.2 1997/05/05 21:46:31 cnidr Exp $ */
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:		db_zclient.hxx
Version:	$Revision: 1.2 $
Description:	SAPI object to contact other Z39.50 servers
Author:		Kevin Gamiel, kevin.gamiel@cnidr.org
@@@*/

#ifndef _DB_ZCLIENT_HXX_
#define _DB_ZCLIENT_HXX_

#include "sapi_db.hxx"
#include "zclibase.hxx"
#include "rset_zclient.hxx"

#define MAX_SESSIONS 32

class SAPI_DB_ZCLIENT 
  : public SAPI_DB {
    friend SAPI_RSET_ZCLIENT;

protected:
    STRLIST	        z_hostList,
                        z_databaseList;
    INT		        z_portList[MAX_SESSIONS],
                        z_clientCount;
    ZCLIENT_BASE	z_clientList[MAX_SESSIONS];
    STRING	        z_password;

public:
    SAPI_DB_ZCLIENT(const STRING & Name, REGISTRY *Registry);
    ~SAPI_DB_ZCLIENT();

    GDT_BOOLEAN	Initialize(STRING pass);
    SAPI_RSET	*Search(const ZSQUERY & Query);

};

#endif
