#include "defs.hxx"      
#include "string.hxx"    
#include "vlist.hxx"                                                     
#include "attr.hxx"                                                
#include "attrlist.hxx"  
#include "strlist.hxx"                                                 
#include "strstack.hxx"                                                  
#include "nfield.hxx" 
#include "mdtrec.hxx" 
#include "mdt.hxx"                                                    
#include "dfd.hxx"                                                    
#include "dfdt.hxx"                                                     
#include "fc.hxx"                    
#include "fct.hxx"    
#include "df.hxx"                                                       
#include "dft.hxx"                                                      
#include "record.hxx"                                                     
#include "result.hxx"  
#include "idbobj.hxx"  
#include "iresult.hxx"                                                    
#include "opobj.hxx"                                                     
#include "operand.hxx"                                                    
#include "termobj.hxx" 
#include "sterm.hxx"                                              
#include "rset.hxx"                                                      
#include "irset.hxx"                                   
#include "opstack.hxx" 
#include "squery.hxx"                                              
#include "dtreg.hxx"                                                    
#include "rcache.hxx"                                                     
#include "index.hxx"                                                    
#include "fprec.hxx"                                       
#include "fpt.hxx"                                                       
#include "registry.hxx"
#include "idb.hxx"   
#include "dfd.hxx"
#include "dfdt.hxx"

#include "rset_Isearch.hxx"
#include "db_Isearch.hxx"
#include "mime_record.hxx"

SAPI_RSET_ISEARCH::SAPI_RSET_ISEARCH(SAPI_DB_ISEARCH *Database, 
	RSET *ResultSet) : SAPI_RSET(Database)
{
	i_rset = ResultSet;
}

SAPI_RSET_ISEARCH::~SAPI_RSET_ISEARCH()
{
	if(i_rset)
		delete i_rset;
}

GDT_BOOLEAN SAPI_RSET_ISEARCH::Present(const INT4 StartPoint, const INT4
	NumberRequested, const STRING & ElementSetName,
	const STRING & RecordSyntax, PLIST *RecordList)
{

	MIME_RECORD *mr;
	char buf[64];
	SAPI_DB_ISEARCH *db;
	db = (SAPI_DB_ISEARCH *)r_database;

	for(INT4 i=StartPoint;i<=NumberRequested+StartPoint-1;i++) {
		RESULT RsRecord;
		STRING Buffer;
		

		i_rset->GetEntry(i, &RsRecord);

		db->i_idb->Present(RsRecord, ElementSetName, 
			RecordSyntax, &Buffer); 

		mr = new MIME_RECORD(Buffer);
		RecordList->AddTail(mr);
	}

	return GDT_TRUE;
}
