#include "defs.hxx"      
#include "string.hxx"    
#include "vlist.hxx"                                                     
#include "attr.hxx"                                                
#include "attrlist.hxx"  
#include "strlist.hxx"                                                 
#include "strstack.hxx"                                                  
#include "nfield.hxx" 
#include "mdtrec.hxx" 
#include "mdt.hxx"                                                    
#include "dfd.hxx"                                                    
#include "dfdt.hxx"                                                     
#include "fc.hxx"                    
#include "fct.hxx"    
#include "df.hxx"                                                       
#include "dft.hxx"                                                      
#include "record.hxx"                                                     
#include "result.hxx"  
#include "idbobj.hxx"  
#include "iresult.hxx"                                                    
#include "opobj.hxx"                                                     
#include "operand.hxx"                                                    
#include "termobj.hxx" 
#include "sterm.hxx"                                              
#include "rset.hxx"                                                      
#include "irset.hxx"                                   
#include "opstack.hxx" 
#include "squery.hxx"                                              
#include "dtreg.hxx"                                                    
#include "rcache.hxx"                                                     
#include "index.hxx"                                                    
#include "fprec.hxx"                                       
#include "fpt.hxx"                                                       
#include "registry.hxx"
#include "idb.hxx"   
#include "dfd.hxx"
#include "dfdt.hxx"

#include "rset_zclient.hxx"
#include "db_zclient.hxx"
#include "zrecords.hxx"
#include "marc.hxx"
#include "mime_record.hxx"

SAPI_RSET_ZCLIENT::SAPI_RSET_ZCLIENT(SAPI_DB *Database) : SAPI_RSET(Database)
{
}

SAPI_RSET_ZCLIENT::~SAPI_RSET_ZCLIENT()
{
}

GDT_BOOLEAN SAPI_RSET_ZCLIENT::Present(const INT4 LocalStartPoint, 
				       const INT4 NumberRequested, 
				       const STRING & ElementSetName,
				       const STRING & RecordSyntax, 
				       PLIST *RecordList)
{
  INT4 i;
  INT StartPoint=LocalStartPoint;
  SAPI_DB_ZCLIENT *db;
  db = (SAPI_DB_ZCLIENT *)r_database;

#ifdef DEBUG
  cout << "ZCLP: "<<ElementSetName << endl;
#endif
  INT4 FetchCount = 0;
  ZRECORDLIST *HitList;
  STRING RSN="Default";

  // get client count and dive requested number by count
  // get that number of records from each client
  
  HitList = new ZRECORDLIST();
  
  INT SumOfPreviousHits=0;
  INT OldSum=0;
  INT FromThisDb;
  INT NumberRemaining=NumberRequested;
  
  for(i=0;i<db->z_clientCount;i++) 
    {
      
      SumOfPreviousHits+=db->z_clientList[i].GetHitCount();
      
      if(StartPoint>SumOfPreviousHits){
	OldSum=SumOfPreviousHits;
#ifdef DEBUG
	cout << "Just looped: Oldsum =  " << OldSum <<endl;
#endif
	continue;
      }
      // StartPoint-=OldSum;
      // we've found the first db to retrieve from
      if(NumberRemaining<=db->z_clientList[i].GetHitCount()){
	
	// Get NumberRemaining and be done
	db->z_clientList[i].Present(StartPoint-OldSum, NumberRemaining,
				    RecordSyntax, RSN,ElementSetName, HitList);
	FetchCount+=NumberRemaining;
	NumberRemaining=0;
	break;			// exit for loop

      } else {
	
	// I need more than are in this set - retrieve GetHitCount()
	// entries and keep going....
	db->z_clientList[i].Present(StartPoint-OldSum,
				    db->z_clientList[i].GetHitCount()-
				    ((StartPoint-OldSum)-1),
				    RecordSyntax, RSN,ElementSetName, HitList);
	NumberRemaining-=db->z_clientList[i].GetHitCount();
	FetchCount+=db->z_clientList[i].GetHitCount();
      }
      OldSum=SumOfPreviousHits;
      StartPoint=0;
    }
  
  // all our records for this batch are ready.
#ifdef DEBUG
  cout << "There were " << FetchCount << " records returned" << endl;
#endif
  ZRECORDSCHOICE *Record;
  STRING RawData, Data, OID;
  
  STRING RecordData;
  CHR dbn[256];
  MIME_RECORD *m;
  char recbuf[1024];
  
  for(INT4 j=0;j < FetchCount;j++) {
    Record = HitList->GetRecord(j,dbn);
    if(!Record)
      continue;
    Record->GetOID(&OID);
    Record->GetRecordData(&RawData);
    if (OID == USMARC_OID) {
      MARC *mr;
      mr = new MARC(RawData);
      mr->SetDisplayFormat(MARC_FORMAT_TITLE);
      mr->SetDisplayWidth(70);
      mr->GetPrettyBuffer(&Data);
      delete mr;
    }  else
      Data = RawData;
    char *dbname, *host;
    STRING RealHost, RealDbName;

    db->z_databaseList.GetEntry(i+1, &RealDbName);
    db->z_hostList.GetEntry(i+1, &RealHost);
    
    STRING temp;
    if (ElementSetName=="B") {
      temp="(";
      temp.Cat(RealHost);
      temp.Cat("/");
      temp.Cat(RealDbName);
      temp.Cat(") ");
      temp.Cat(Data);
    } else if (ElementSetName=="S") {
      temp="(";
      temp.Cat(RealHost);
      temp.Cat("/");
      temp.Cat(RealDbName);
      temp.Cat(")\n");
      temp.Cat(Data);
    }else
      temp = Data;
    
    m = new MIME_RECORD(temp);
    RecordList->AddTail(m);
  }
  
  return GDT_TRUE;
}
