/* $Id: sapi_db.hxx,v 1.6 1998/02/21 00:34:52 cnidr Exp $ */
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:		sapi_db.hxx
Version:	$Revision: 1.6 $
Description:	SAPI database object base class
Author:		Kevin Gamiel, kevin.gamiel@cnidr.org
@@@*/

#ifndef _SAPI_DB_HXX_
#define _SAPI_DB_HXX_

class SAPI_DB;

#ifndef _BER_HXX_
#include "ber.hxx"
#endif

#ifndef _ZSQUERY_HXX_
#include "zsquery.hxx"
#endif

#include "sapi_rset.hxx"


class SAPI_DB {
protected:
  INT			d_debugLevel;
  STRING 		d_name,d_type,
                        d_location;
  REGISTRY*		d_registry;
  STRING 		d_errorMessage;

public:
  SAPI_DB(const STRING & Name,REGISTRY *Registry);
  virtual 		~SAPI_DB();
  void 			GetName(STRING *Name) { *Name = d_name;}
  void 			GetType(STRING *Type) { *Type = d_type;}
  virtual GDT_BOOLEAN	Initialize(STRING pass) = 0;
  virtual GDT_BOOLEAN   Spawn() {return GDT_TRUE;}
  virtual SAPI_RSET*	Search(const ZSQUERY & Query) = 0;
  virtual GDT_BOOLEAN   Add_Record(const STRING &Key,const STRING &Data)
                        { return GDT_FALSE; }
  virtual GDT_BOOLEAN   Delete_Record(const STRING &Key)
                        { return GDT_FALSE; }
  virtual void          GetFieldNames(STRLIST *FieldNames)
                        { FieldNames->Clear(); }	
  void			GetLastErrorString(STRING *Reason) 
                        {*Reason = d_errorMessage; }
  virtual void		SetDebugLevel(const INT Level)
                        { d_debugLevel = Level;}
};

#endif
