/* $Id: refer.cxx,v 1.3 1997/03/11 14:21:30 cnidr Exp $ */
/************************************************************************
Copyright Notice
 
Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994.
 
Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that
 
1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact.
 
2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software.
 
3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR.
 
THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
 
IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
************************************************************************/

#include <iostream.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <stdlib.h>
#include <signal.h>
#ifdef UNIX
#include <unistd.h>
#endif
#include "config.hxx"
#include "ztags.hxx"
#include <string.h>
#include "defs.hxx"
#include "string.hxx"
#include "vlist.hxx"
#include "strlist.hxx"
#include "tokengen.hxx"
#include "strstack.hxx"
#include "infix2rpn.hxx"
#include "gdt.h"
#include "cgi.hxx"

void USR1Handler(int t);
void MyExit(INT Status);

volatile GDT_BOOLEAN WaitingForSignal;
char *TempFile;

CHR *Action;
CHR *Host, *Tmp;
UINT Port;
CHR *DBName, *DBInfo;
STRLIST List;
INT PID;
enum { FROM_COMMANDLINE, FROM_CGI } Source;
STRING TempString;
struct stat statbuf;

int main(int argc, char **argv)
{
	CGI *cgi;
	int i;
	int max_open_files;
	CHR mypath[1024];
	FILE *fp,*fy;

	getcwd(mypath, sizeof(mypath));
	ios::sync_with_stdio();

	if ((max_open_files = (int)sysconf(_SC_OPEN_MAX)) < 0) {
		cout << "I can't determine the maximum number of open files!";
		cout << endl;
		MyExit(1);
	}

	for (i = 3; i < max_open_files; i++)
		close(i);

	signal(SIGUSR1, USR1Handler);

	cout << "Content-type: text/html" << endl << endl;
	//cout << "<A HREF=\"http://www.cnidr.org/\">CNIDR</A> http to Z39.50 gateway, Version " << VERS << endl;

		// Read from command-line instead of CGI
		pid_t PID = atoi(argv[1]);
		TempFile = new CHR[1024];
		sprintf(TempFile, "/tmp/zcon.%ld", PID);
		if((fp = fopen(TempFile, "w")) == NULL) {
			perror(TempFile);
			MyExit(1);
		}
		CHR Term[256];
		CHR TTerm[256];
		strcpy(TTerm,argv[2]);
		if(toupper(TTerm[0]=='L') && isdigit(TTerm[1])){
			sprintf(Term,"#%s",TTerm);
		}else if(TTerm[0]=='P'){
			sprintf(Term,"%s[1,2553]",&TTerm[1]);
		}else
			strcpy(Term,TTerm);
			

//fy=fopen("/tmp/j3","a");
//		fprintf(fy, "%ld\nSEARCH\n%s\n%s\n%s\n%s\n%s\n",getpid(),
//			argv[3], Term, argv[4], "1.2.840.10003.5.101",argv[5] );
//fclose(fy);
		fprintf(fp, "%ld\nSEARCH\n%s\n%s\n%s\n%s\n%s\n",getpid(),
			argv[3], Term, argv[4], "1.2.840.10003.5.101",argv[5] );
		fclose(fp);

		WaitingForSignal = GDT_TRUE;
char HistoryFile[256];
	CHR *p;
	p=strchr(Term,'[');
	if(p){
*p='\0';
	}
                        sprintf(HistoryFile,"/tmp/hx.%ld",PID);
                        fp=fopen(HistoryFile,"a");
                        fprintf(fp,
                                "<TR><TD>%s</TD><TD>%s</TD>",
                                argv[3],Term);
                        fclose(fp);

		if((PID>) && (kill(PID, SIGUSR1) == -1)) {
			cout << "Your session has expired.  Please ";
			cout << "<A HREF=\"/gw.html\">reinitialize.</A>";
			cout << endl;
			unlink(TempFile);
			MyExit(0);	
		}
		while(WaitingForSignal);
		MyExit(0);
}


void USR1Handler(int t)
{
	// Read results from TempFile
	FILE *fp;

	if((fp = fopen(TempFile, "r")) == NULL) {
		perror(TempFile);
		unlink(TempFile);
		MyExit(1);
	}

	char buf[1024];
		while(fgets(buf, sizeof(buf), fp))
			cout << buf;

	fclose(fp);
	unlink(TempFile);	
	MyExit(1);
}

void MyExit(INT Status)
{
	fclose(stdout);
	fclose(stdin);
	fclose(stderr);

	exit(Status);
}
