/* $Id: zcon.hxx,v 1.5 1997/11/13 01:55:40 cnidr Exp $ */
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1994.

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact.

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of
noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
************************************************************************/

struct _Data {
  int             cmd_coun, command, start, count; 
  int             NumReq, MaxRecords, lnum, DisplayCnt;
  int             RecsPerServer;
  char            db[10240], resultset[10240], term[256], esname[128];
  char            recsyntax[128],attrset[128];
  CHR             GlobalUserId[256];
  int             LHIT[102];	/* we support 100 named result sets 
				   (L numbers) */
  char            gCommandFile[1024];
  pid_t           CallersPID;
  unsigned int    Timeout;
} LocalData;

INT             GetCurrentSNumber();
void            GetCurrentSQuery(char *s);
#ifndef __SUNPRO_CC
void            AlarmHandler(int t);
void            KillHandler(int t);
void            USR1Handler(int t);
void            USR2Handler(int t);
#else
void            AlarmHandler(int t,...);
void            KillHandler(int t,...);
void            USR1Handler(int t,...);
void            USR2Handler(int t,...);
#endif
void            ShowGeneralButtons(FILE * fp);
void            ShowScanButtons(FILE * fpc);
void            ShowCmtButtons(FILE * fp);
void            ShowLogoutButton(FILE * fp);
void            ShowHitsHlpButton(FILE * fp);
void            ShowDocHeader(FILE * fp);
void            ShowDocTrailer(FILE * fp);
void            ShowGetMoreForm(FILE * fp, INT start, INT HitCount,
				INT FetchCount,	INT MaxCount, 
				char * recsyntax);
void            ExecutePresent(FILE *fp,int lnum,char *resultset, int start, 
			       int count, char *esname,char *recsyntax);
char           *ProcessRecord(char *s, INT Link);
void            ExecuteLogOut(FILE *fp, pid_t CallersPID, 
			      ZCLIENT_BASE *zclient);
void            ExecuteSearch(FILE *fp, char *db, char *term, int lnum, 
			      int start,int MaxRecords,int HitsPerServer,
			      char *esname, char *recsyntax);
void            ExecuteScan(FILE *fp, INT NumReq, char *db, char *term);
void            Process(struct _Data *l);
void            Initialize(char *mp);
