# $Id: zdist.mak,v 1.11 1998/02/23 20:36:43 cnidr Exp $
#
#  Answer the following questions and type 'make build'.
#

RM=del

#
# Compiler and Compiler flags? 
#

!IFNDEF WIN16
!include <ntwin32.mak>
CFLAGS=$(cflags) $(cvarsmt) -DVERS=\"2.00\"
!ELSE
CFLAGS=-Alfw -F 4000 -G3 -Oceglot -W3 -Zi -Dstrcasecmp=stricmp -Dstrncasecmp=strnicmp -DVERS=\"2.00\"
!ENDIF

#
# Where is your Isearch distribution?
#
ISEARCH_DIR=..\Isearch
ISEARCH_LIB_DIR=..\exe
ISEARCH_INC=-I $(ISEARCH_DIR)\src -I $(ISEARCH_DIR)\doctype

#
# Where do you want the binaries stored?
#
BIN_DIR=..\exe

#
# Where are the libraries with which I need to link?
#
# This makefile requires that all required libraries are in one directory.
#
# The required libraries include: libsapi.a, libz3950.a and libIsearch.a
#
LIB_DIR=..\exe

#
# Where are the CNIDR Search API (libsapi) include files located?
#
SAPI_DIR=..\sapi2
SAPI_LIB=$(LIB_DIR)\libsapi.lib
ISEARCH_LIB=$(LIB_DIR)\Isearch.lib

#
# Resulting Library
#
Z3950_LIB=$(LIB_DIR)\z3950.lib

#
# Librarian
#
# Select your platform and comment/uncomment the appropriate ARFLAGS
#
AR=lib
!IFNDEF WIN16
ARFLAGS=-out:$(Z3950_LIB)
!ELSE
ARFLAGS=$(Z3950_LIB) +
!ENDIF
#
# STOP!!
#
# Hopefully, you didn't have to change anything above.  Chances are,
# you'll never have to change anything below.
  
LIBRARY=$(Z3950_LIB) $(SAPI_LIB) $(ISEARCH_LIB)
  
INC=$(ISEARCH_INC)
LZ_OBJ=berutil.obj ber.obj zpdu.obj zsession.obj zsquery.obj unisock.obj \
        tcpbuf.obj tcpstr.obj tcpsock.obj ipbuf.obj zrecords.obj \
        zclibase.obj cgi.obj httpbox.obj ping.obj config.obj
  
LZ_H=berutil.hxx ber.hxx zpdu.hxx zsession.hxx unisock.hxx zsquery.hxx \
        tcpbuf.hxx tcpstr.hxx tcpsock.hxx ipbuf.hxx zrecords.hxx \
        zclibase.hxx userinfo.hxx ztags.hxx cgi.hxx httpbox.hxx
  
all:$(LZ_OBJ) $(Z3950_LIB) $(BIN_DIR)\zclient.exe $(BIN_DIR)\zserver.exe \
        $(BIN_DIR)\izclient.exe $(BIN_DIR)\zping.exe $(BIN_DIR)\zbatch.exe

berutil.obj:$(LZ_H) berutil.cxx
        $(CC) $(CFLAGS) $(INC) -c berutil.cxx

ber.obj:$(LZ_H) ber.cxx
        $(CC) $(CFLAGS) $(INC) -c ber.cxx

config.obj:$(LZ_H) config.cxx
        $(CC) $(CFLAGS) $(INC) -c config.cxx

zpdu.obj:$(LZ_H) zpdu.cxx defines.hxx
        $(CC) $(CFLAGS) $(INC) -c zpdu.cxx

zsession.obj:$(LZ_H) zsession.cxx
        $(CC) $(CFLAGS) $(INC) -c zsession.cxx

zsquery.obj:$(LZ_H) zsquery.cxx
        $(CC) $(CFLAGS) $(INC) -c zsquery.cxx

unisock.obj:$(LZ_H) unisock.cxx
        $(CC) $(CFLAGS) $(INC) -c unisock.cxx

tcpbuf.obj:$(LZ_H) tcpbuf.cxx
        $(CC) $(CFLAGS) $(INC) -c tcpbuf.cxx

tcpstr.obj:$(LZ_H) tcpstr.cxx
        $(CC) $(CFLAGS) $(INC) -c tcpstr.cxx

tcpsock.obj:$(LZ_H) tcpsock.cxx
        $(CC) $(CFLAGS) $(INC) -c tcpsock.cxx

ipbuf.obj:$(LZ_H) ipbuf.cxx
        $(CC) $(CFLAGS) $(INC) -c ipbuf.cxx

zrecords.obj:$(LZ_H) zrecords.cxx
        $(CC) $(CFLAGS) $(INC) -c zrecords.cxx

userinfo.obj:$(LZ_H) userinfo.cxx
        $(CC) $(CFLAGS) $(INC) -c userinfo.cxx

zclibase.obj:$(LZ_H) zclibase.cxx 
        $(CC) $(CFLAGS) $(INC) -c zclibase.cxx

cgi.obj:cgi.cxx
        $(CC) $(CFLAGS) $(INC) -c cgi.cxx

httpbox.obj:httpbox.cxx
        $(CC) $(CFLAGS) $(INC) -c httpbox.cxx

$(Z3950_LIB):$(LZ_H) $(LZ_OBJ)
	$(RM) $(Z3950_LIB)
        $(AR) $(ARFLAGS) $(LZ_OBJ)

izclient:$(BIN_DIR)\izclient
        @echo.

zclient:$(BIN_DIR)\zclient
        @echo.

zbatch:$(BIN_DIR)\zbatch
        @echo.

zping:$(BIN_DIR)\zping
        @echo.

zserver:$(BIN_DIR)\zserver
        @echo.

izclient.obj:$(LZ_H) izclient.cxx 
        $(CC) $(CFLAGS) $(INC) -c izclient.cxx

zclient.obj:$(LZ_H) zclient.cxx 
        $(CC) $(CFLAGS) $(INC) -c zclient.cxx

zbatch.obj:$(LZ_H) zbatch.cxx 
        $(CC) $(CFLAGS) $(INC) -c zbatch.cxx

ping.obj:$(LZ_H) ping.cxx 
        $(CC) $(CFLAGS) $(INC) -c ping.cxx

zping.obj:$(LZ_H) zping.cxx 
        $(CC) $(CFLAGS) $(INC) -c zping.cxx

#zserver.obj:$(LZ_H) zserver.cxx zserver.hxx
#        $(CC) $(CFLAGS) $(INC) -I$(SAPI_DIR) -c zserver.cxx

# NT-specific threaded server
zs-classNT.obj:$(LZ_H) zs-classNT.cxx zs-classNT.hxx
        $(CC) $(CFLAGS) $(INC) -I$(SAPI_DIR) -c zs-classNT.cxx

zserverNT.obj:$(LZ_H) zserverNT.cxx zserverNT.hxx
        $(CC) $(CFLAGS) $(INC) -I$(SAPI_DIR) -c zserverNT.cxx

$(BIN_DIR)\zclient.exe:$(Z3950_LIB) zclient.obj
!IFNDEF WIN16
	$(link) $(conlflags) -out:$(BIN_DIR)\zclient.exe \
		zclient.obj $(LIBRARY) wsock32.lib $(conlibsmt) libcimt.lib
!ELSE
	link zclient.obj /co /nod, $(BIN_DIR)\zclient.exe, NUL, \
		$(LIBRARY) winsock.lib oldnames.lib llibcewq.lib libw.lib, \
		c:\langs\msvc\bin\cl.def
!ENDIF

$(BIN_DIR)\zbatch.exe:$(Z3950_LIB) zbatch.obj
!IFNDEF WIN16
	$(link) $(conlflags) -out:$(BIN_DIR)\zbatch.exe \
		zbatch.obj $(LIBRARY) wsock32.lib $(conlibsmt) libcimt.lib
!ELSE
	link zbatch.obj /co /nod, $(BIN_DIR)\zbatch.exe, NUL, \
		$(LIBRARY) winsock.lib oldnames.lib llibcewq.lib libw.lib, \
		c:\langs\msvc\bin\cl.def
!ENDIF

$(BIN_DIR)\zping.exe:$(Z3950_LIB) zping.obj
!IFNDEF WIN16
	$(link) $(conlflags) -out:$(BIN_DIR)\zping.exe \
		zping.obj $(LIBRARY) wsock32.lib $(conlibsmt) libcimt.lib
!ELSE
	link zping.obj /co /nod, $(BIN_DIR)\zping.exe, NUL, \
		$(LIBRARY) winsock.lib oldnames.lib llibcewq.lib libw.lib, \
		c:\langs\msvc\bin\cl.def
!ENDIF

$(BIN_DIR)\izclient.exe:$(Z3950_LIB) izclient.obj
!IFNDEF WIN16
	$(link) $(conlflags) -out:$(BIN_DIR)\izclient.exe \
		izclient.obj $(LIBRARY) wsock32.lib $(conlibsmt) libcimt.lib
!ELSE
	link izclient.obj /co /nod, $(BIN_DIR)\izclient.exe, NUL, \
		$(LIBRARY) winsock.lib oldnames.lib llibcewq.lib libw.lib, \
		c:\langs\msvc\bin\cl.def
!ENDIF

# NT-specific threaded server
!IFNDEF WIN16
$(BIN_DIR)\zserver.exe:$(Z3950_LIB) zserverNT.obj zs-classNT.obj
	$(link) $(conlflags) -out:$(BIN_DIR)\zserver.exe \
		zserverNT.obj zs-classNT.obj $(LIBRARY) wsock32.lib \
		$(conlibsmt) libcimt.lib
!ELSE
$(BIN_DIR)\zserver.exe:
	echo.
!ENDIF

clean:
	$(RM) *~
	$(RM) *.pdb
	$(RM) *.obj 
	$(RM) *.pck 
	$(RM) *.bak 
	$(RM) $(Z3950_LIB) 
	$(RM) $(BIN_DIR)\zclient.exe 
	$(RM) $(BIN_DIR)\zserver.exe
	$(RM) $(BIN_DIR)\izclient.exe 
	$(RM) $(BIN_DIR)\zping.exe
	$(RM) $(BIN_DIR)\zbatch.exe

realclean:
	$(RM) *~
	$(RM) *.pdb
	$(RM) *.obj 
	$(RM) *.pck 
	$(RM) *.bak 
	$(RM) $(Z3950_LIB) 
	$(RM) $(BIN_DIR)\zclient.exe 
	$(RM) $(BIN_DIR)\zserver.exe
	$(RM) $(BIN_DIR)\izclient.exe 
	$(RM) $(BIN_DIR)\zping.exe
	$(RM) $(BIN_DIR)\zbatch.exe
