/* $Id: zutils.hxx,v 1.6 1998/01/30 19:17:45 cnidr Exp $ */
/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery
and Retrieval, 1996.

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby
granted without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact.

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of
noteworthy uses of this software.

3. The names of MCNC and Clearinghouse for Networked Information
Discovery and Retrieval may not be used in any advertising or publicity
relating to the software without the specific, prior written permission
of MCNC/CNIDR.

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
************************************************************************/


/*@@@
File:		zutils.hxx
Version:	1.00
Description:	Z39.50 gateway utilities
Author:		Archie Warnock (warnock@clark.net), A/WWW Enterprises
@@@*/

#ifndef _ZUTILS_HXX_
#define _ZUTILS_HXX_

CHR *BuildKWAQS(CHR *Term, CHR *Use, CHR* StructureTag, CHR *RelationTag);
CHR *ProcessDateTerms(CHR *Term, CHR *Use, CHR* StructureTag, 
		      CHR *RelationTag);
CHR *BuildFGDCDate(CHR *Year, CHR *Month, INT Day);
void SetOption(CGI *cgi, STRING& Buf, CHR *field, CHR *default_string); 
GDT_BOOLEAN SetValue(CGI *cgi, STRING& Buf, CHR *field, CHR *default_string);
void SetRadio(CGI *cgi, STRING& Buf, CHR *field, CHR *default_string);
void MyExit(INT Status);

/// Show the search form to the user's browser
void DisplaySearchForm(CHR *Filename, 
			 CHR *MapString,
			 CHR *min_lat, CHR *max_lat, 
			 CHR *min_lon, CHR *max_lon,
			 INT NumDatabases,
			 CHR *database_names[], CHR *database_values[],
			 INT SessionId, char *Motd);

void         ShowDocHeader();
void         ShowDocTrailer();

//#define DEFAULT_TIMEOUT 180
#define MAX_SERVERS 150

#ifndef min
#define min(a,b) ((a) <= (b) ? (a) : (b))
#endif

///////////////////////////
// GLOBALS FOR MAP SUPPORT
#define MAX_MAP_WIDTH   300
#define MAX_MAP_HEIGHT  300
#define CROSS_OFFSET    20
#define FORMNAME    	"search.html"
#define MAP_URL		"http://www-mel.nrlmry.navy.mil/mel-bin/v1.0/drawroi?"
// END GLOBAL MAP SUPPORT
///////////////////////////

#endif
